import pygame, sys, random,time

def draw_text(text,screen,y_pos = 5,x_pos = 5):
    font = pygame.font.SysFont("arial", 25)
    for line in text.splitlines():
        for pos in range(1, len(line)+1):
            text = font.render(line[:pos], 1, (255, 255, 255))
            screen.blit(text, (x_pos, y_pos))
            pygame.display.update()
            #time.sleep(0.02)
        y_pos += 25
        x_pos += 0

class Feld(pygame.sprite.Sprite):
    def __init__(self,b,h,x,y,Nummer=[0,0],color=(255,255,255), Bestizer=0):
        super().__init__()
        self.image =pygame.Surface([b,h])
        self.image.fill(color)
        self.rect = self.image.get_rect()
        self.rect.topleft = [x,y]
        self.Nummer=Nummer
        self.Color=color
        self.Set=False
    def Feld_Update(self,G):
        self.Color=G.Player_color[G.Player+2]
        self.image.fill(self.Color)
        self.Set=True
        return


class Linie(pygame.sprite.Sprite):
    def __init__(self,b,h,x,y,Nummer=[0,0],color=(255,255,255)):
        super().__init__()
        self.image =pygame.Surface([b,h])
        self.image.fill(color)
        self.rect = self.image.get_rect()
        self.rect.topleft = [x,y]
        self.Nummer=Nummer
        self.Color=color
        self.Set=False
    def Update(self):
        self.image.fill(self.Color)
        self.Set=True
        return


def Init_Linien(start_x,start_y,b,h,dicke,lang,Linien_gruppe):
    for i in range(h):
        for j in range(b):
            neue_linie = Linie(lang, dicke, start_x+(lang+dicke)*j, start_y+(lang+dicke)*i-dicke,[j,i*2])
            Linien_gruppe.add(neue_linie)
            neue_linie = Linie(dicke, lang, start_x+(lang+dicke)*j-dicke, start_y+(lang+dicke)*i,[j,i*2+1])
            Linien_gruppe.add(neue_linie)
        neue_linie = Linie(dicke, lang, start_x+(lang+dicke)*b-dicke, start_y+(lang+dicke)*i,[b,2*i+1])
        Linien_gruppe.add(neue_linie)
    for j in range(b):
        neue_linie = Linie(lang, dicke, start_x+(lang+dicke)*j, start_y+(lang+dicke)*h-dicke,[j,h*2])
        Linien_gruppe.add(neue_linie)

def Init_Felder(start_x,start_y,b,h,dicke,lang,Feld_gruppe):
    for i in range(h):
        for j in range(b):
            neues_Feld = Feld(lang,lang,start_x+(lang+dicke)*j,start_y+(lang+dicke)*i,[j,i],(0,0,0))
            Feld_gruppe.add(neues_Feld)

def Init_Dict(b,h):
    Dict={}
    for i in range(h):
        for j in range(b):
            Dict[j,i,0]= [j,2*i]
            Dict[j,i,1]= [j+1,2*i+1]
            Dict[j,i,2]= [j,2*i+2]
            Dict[j,i,3]= [j,2*i+1]
    print(Dict)
    return Dict



def Dict_get(Dict, Nummer):
    f=[]
    for Feld, Linie in Dict.items():
        if Linie == Nummer:
            f.append(Feld)
            print("Dict: Linie: ",Linie, "  Feld: ", Feld)
    return f

def Get_Linie(Linien_gruppe, Nummer):
    for L in Linien_gruppe:
        if L.Nummer == Nummer:
            return L
def Get_Feld(Feld_gruppe, Nummer):
    for F in Feld_gruppe:
        if F.Nummer == Nummer:
            return F

def Set_Linie(Linien_gruppe, Nummer):
    L=Get_Linie(Linien_gruppe, Nummer)
    L.Set=True


def Check_Feld(Dict,Feld, Linien_gruppe):
    Set=[]
    for k in range(4):
        L=Dict[Feld[0],Feld[1],k]
        Linie=Get_Linie(Linien_gruppe, L)
        #print(Linie.Set)
        print("Check_Feld: ",k, "  ", Linie.Set)
        if Linie.Set==False:
            return False
    return True


def Init_Spiel(start_x,start_y,b,h,dicke,lang,Linien_gruppe,Feld_gruppe):
    Init_Linien(start_x,start_y,b,h,dicke,lang,Linien_gruppe)
    Init_Felder(start_x,start_y,b,h,dicke,lang,Feld_gruppe)

class Game():
    def __init__(self):
        super().__init__()
        self.Player=0
        self.Player_color=[(100,230,150),(170,100,230),(50,170,100),(100,50,170)]
        self.Player_Punkte=[0,0]
        self.has_changed=False
        self.Counter=1
    def Change_Player(self):
        if self.Player==0:
            self.Player=1
        else:
            self.Player=0
    def Set_Linie(self, Nummer, Dict, Linien_gruppe,Feld_gruppe):
        Set_Linie(Linien_gruppe, Nummer)
        Felder=Dict_get(Dict, Nummer)
        C=False
        for Feld in Felder:
            C=Check_Feld(Dict,Feld, Linien_gruppe) or C
            Check=Check_Feld(Dict,Feld, Linien_gruppe)
            print(Check)
            if Check:
                F=Get_Feld(Feld_gruppe, [Feld[0],Feld[1]])
                F.Feld_Update(self)
                self.Player_Punkte[self.Player] +=1
                self.has_changed=True
        print("Feld: ",Feld)
        if not C:
            self.Change_Player()
            return
    def Count_up(self):
        self.Counter+=1
    def Check_Win(self,b,h):
        print("_______________________")
        a=False
        Gewinner=0
        if self.Player_Punkte[0]+self.Player_Punkte[1]==b*h:
            if self.Player_Punkte[0]>self.Player_Punkte[1]:
                Gewinner=1
            else:
                Gewinner=2
            a=True

        Info=[a,Gewinner]
        print("---Info ", self.Counter," : ", Info)
        return Info










def random_color(r=(0,255),g=(0,255),b=(0,255)):
    red=random.randint(r[0],r[1])
    green=random.randint(g[0],g[1])
    blue=random.randint(b[0],b[1])
    color=(red,green,blue)
    return color

##def Change_Player(Player):
##    #global Player
##    if Player==0:
##        Player=1
##    else:
##        Player=0
##    return Player

def Main(b,h,width = 1280,height = 720):

    G=Game()
    BG_Gruppe=pygame.sprite.Group()
    BG=Init_Felder(0,0,1,1,170,170,BG_Gruppe)


    Linien_gruppe= pygame.sprite.Group()
    Feld_gruppe= pygame.sprite.Group()
    pygame.init()
    clock = pygame.time.Clock()


    screen = pygame .display. set_mode((width,height))
    #Init_Linien(100,100,5,3,10,100,Linien_gruppe)
    Init_Spiel(100,100,b,h,10,100,Linien_gruppe,Feld_gruppe)
    Dict=Init_Dict(b,h)
    Player=0
    Player_color=[(100,230,150),(170,100,230)]
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
            if event.type == pygame.MOUSEBUTTONDOWN:
                mouse_pos=pygame.mouse.get_pos()
                for Linie in Linien_gruppe:
                    if Linie.rect.collidepoint(mouse_pos):
                        print(Linie.Nummer)
                        Dict_get(Dict, Linie.Nummer)
                        if not Linie.Set:
                            Linie.Color=G.Player_color[G.Player]
                            G.Set_Linie(Linie.Nummer, Dict, Linien_gruppe,Feld_gruppe)
                            G.Count_up()
                            #Player=Change_Player(Player)
                            #Linie.Nummer
                            Linie.Update()
                            print ('yay!')
                for Feld in Feld_gruppe:
                    if Feld.rect.collidepoint(mouse_pos):
                        print(Feld.Nummer)
            if G.has_changed:
                print("Spieler 1:  "+str(G.Player_Punkte[0])+"\n"+"Spieler 2:  "+str(G.Player_Punkte[1]))
                G.has_changed=False
                BG_Gruppe.draw(screen)
                draw_text("Spieler 1:  "+str(G.Player_Punkte[0])+"\n"+"Spieler 2:  "+str(G.Player_Punkte[1]),screen)
                if G.Check_Win(b,h)[0]:
                    if G.Player_Punkte[0]!=G.Player_Punkte[1]:
                        draw_text("Spieler "+str(G.Check_Win(b,h)[1])+" hat  mit "+str(G.Player_Punkte[G.Check_Win(b,h)[1]-1])+" Punkten gewonnen!",screen, 5,200)
                    else:
                        draw_text("Unentschieden",screen,5,200)
            pygame.display.flip()
            #screen.blit(background,(0,0))
            #Linien_gruppe.Update()

            Linien_gruppe.draw(screen)
            Feld_gruppe.draw(screen)

            clock.tick(60)

Main(3,3)
